#
# START COPYRIGHT-NOTICE: 2002-2003
#
# Copyright 2002-2003 VERITAS Software Corporation.
# All rights reserved.
#
# VERITAS, VERITAS SOFTWARE, the VERITAS logo and all other VERITAS
# product names and slogans are trademarks or registered trademarks
# of VERITAS Software Corporation in the USA and/or other countries.
# Other product names and/or slogans mentioned herein may be trade-
# marks or registered trademarks of their respective companies.
#
# END COPYRIGHT-NOTICE.
#

package MirrorViewAgent;
use ArrayRep;
use POSIX qw(uname);
@ISA = ("ArrayRep");

use strict;
use vars qw($VERSION @ISA @EXPORT @EXPORT_OK %default);

@EXPORT = qw(
);
$VERSION = '1.00';

require 5.000;
my $vcs_home=$ENV{"VCS_HOME"} || "/opt/VRTSvcs";
my $java_home="/opt/VRTSjre/jre1.4/bin";

use ag_i18n_inc;


sub new {
        my($self) = shift;
        my($resname) = shift;
        my($naviclihome) = shift;
	my $i=0;
	my ($numLocalarraySPNames) = shift;
	my @LocalarraySPNames;
	for($i=0; $i<$numLocalarraySPNames; $i++){
  		@LocalarraySPNames[$i] = shift;
  	}
	my ($numRemotearraySPNames) = shift;
	my @RemotearraySPNames;
	$i=0;
	for($i=0; $i<$numRemotearraySPNames; $i++){
		@RemotearraySPNames[$i] = shift;
	}
        my($mode) = shift;
        my($grpname) = shift;
        my($numMirrors) = shift;
	$i=0;
	my @mirnames;
	my (%mir_states) = ();
	my (%mir_roles) = ();
	my (%mir_conditions) = ();
	my (%mir_imageuid) = ();
	my (%mir_remoteuid) = ();
	my (%mir_updatetype) = ();
	my (%mir_updatetime) = ();


	# populate our mirrorNames array
	for($i=0; $i<$numMirrors; $i++){
    		@mirnames[$i] = shift;
		$mir_states{@mirnames[$i]} = "";
		$mir_roles{@mirnames[$i]} = "";
		$mir_conditions{@mirnames[$i]} = "";
		$mir_imageuid{@mirnames[$i]} = "";
		$mir_remoteuid{@mirnames[$i]} = "";
		$mir_updatetype{@mirnames[$i]} = "";
		$mir_updatetime{@mirnames[$i]} = "";
	}
        my($splitTakeover) = shift;

	my($arrayname)="NOARRAYSP";
	$i=0;
	for($i=0; $i<$numLocalarraySPNames; $i++){
		if (&PingTest($LocalarraySPNames[$i])) {
        		VCSAG_LOG_MSG("N", "Local array SP $LocalarraySPNames[$i] is unreachable.", 1, $LocalarraySPNames[$i] );
		} else {
			$arrayname = $LocalarraySPNames[$i];
			last;
		}
	}

	my($remotearray)="NOARRAYSP";
	$i=0;
	for($i=0; $i<$numRemotearraySPNames; $i++){
		if (&PingTest($RemotearraySPNames[$i])) {
        		VCSAG_LOG_MSG("N", "Remote array SP $RemotearraySPNames[$i] is unreachable.", 2, $RemotearraySPNames[$i] );
		} else{
			$remotearray = $RemotearraySPNames[$i];
			last;
		}
	}

	$self = {
		"resname" => $resname,
		"naviclihome" => $naviclihome,
		"arrayname" => $arrayname,
		"remotearray" => $remotearray,
		"mode" => $mode,
		"grpname" => $grpname,
		"numMirrors" => $numMirrors,
		"splitTakeover" => $splitTakeover,
		"state" => '',
		"role" => '',
		"condition" => '',
		"grpudpatetype" => '',
		"grpupdatetime" => '',
		"flag" => '',
		"RETRY_ATTEMPTS" => 6,
		"start_time" => $
	};
	$self->{LocalarraySPNames} = \@LocalarraySPNames;
	$self->{RemotearraySPNames} = \@RemotearraySPNames;
	$self->{mirnames} = \@mirnames;
	$self->{'flag'} = "-" . $self->{'mode'};
	$self->{MIR_STATES} = \%mir_states;
	$self->{MIR_ROLES} = \%mir_roles;
	$self->{MIR_CONDITIONS} = \%mir_conditions;
	$self->{MIR_IMAGEUID} = \%mir_imageuid;
	$self->{MIR_REMOTEUID} = \%mir_remoteuid;
	$self->{MIR_UPDATETYPE} = \%mir_updatetype;
	$self->{MIR_UPDATETIME} = \%mir_updatetime;

	my $class = ref($self) || $self;
	bless $self;
	return $self;
}

sub DESTROY {}


sub get_state {
	my $self = shift;
	my $nolog = shift;
	$self->{'role'} = "";

	if (($self->{'mode'} eq "async") && ($self->{'grpname'} ne "")) {
		my $cmd = $java_home . "/java -jar " . $self->{'naviclihome'} . "/navicli.jar -h " .  $self->{'arrayname'} . " mirror -async -listgroups -name " . $self->{'grpname'}  . " -role -state -condition -update";

		if (!$nolog){
			VCSAG_LOG_MSG("W", "Getting the role, state, condition and update policy for group:$self->{'grpname'}", 3, $self->{'grpname'});
			my $logcmd = "$java_home/java -jar $self->{'naviclihome'}/navicli.jar -h $self->{'arrayname'} mirror -async -listgroups -name $self->{'grpname'} -role -state -condition -update";
			log_command($logcmd);
		}

		my $i=0;
		my @query = split('\n', `$cmd`);
		foreach my $q (@query) {
			if ($q =~ /Role/) {
				my @roleinfo = split('\s+', $q);
				if ($roleinfo[1] eq "Primary") {
					$self->{'role'} = "PRIMARY";
				} elsif ($roleinfo[1] eq "Secondary") {
					$self->{'role'} = "SECONDARY";
				} else {
					$self->{'role'} = "Invalid";
				}		
			}

			if ($q =~ /State/) {
				my @stateinfo = split('\s+', $q);
				$self->{'state'} = $stateinfo[1];
			}

			if ($q =~ /Condition/) {
				my @conditioninfo = split('\s+', $q);
				$self->{'condition'} = $conditioninfo[1];
			}

			if ($q =~ /Update Type/) {
				my @updateinfo = split('\s+', $q);
				$self->{'grpudpatetype'} = $updateinfo[2];
				if ($self->{'grpudpatetype'} eq "Manual") {
					$self->{'grpupdatetime'} = 0;
					last;
				} else {
					$self->{'grpudpatetype'} = $updateinfo[5];
					next;
				}
			}

			if ($q =~ /Update Period, in minutes/) {
				my @times = split('\s+', $q);
				$self->{'grpupdatetime'} = $times[4];
				last;
			}
		}
	} else {
		if (!$nolog){
			VCSAG_LOG_MSG("W", "Getting the role, state, condition and UID(s) for mirror(s)", 4);
		}
		my $cmd = $java_home . "/java -jar " . $self->{'naviclihome'} . "/navicli.jar -h " .  $self->{'arrayname'} . " mirror " . $self->{'flag'} . " -list -name ";
		my $logcmd = "$java_home/java -jar $self->{'naviclihome'}/navicli.jar -h $self->{'arrayname'} mirror $self->{'flag'} -list -name ";

		my $i=0;
		for($i=0; $i < $self->{'numMirrors'}; $i++){
			my $mirror = $self->{mirnames}[$i];
			my $localUID = "";

			my $logcmd = $logcmd . " $mirror";

			if (!$nolog){
				log_command($logcmd);
			}

			my @query = split('\n', `$cmd $mirror`);
			foreach my $q (@query) {
				if ($q =~ /Remote Mirror Status/) {
					my @roleinfo = split('\s+', $q);
					if (($roleinfo[3] eq "Mirrored") || 
					($roleinfo[3] eq "Mirrored/No")) {
						$self->{MIR_ROLES}{$mirror} = "PRIMARY";
						if ($self->{'role'} eq "SECONDARY") {
							$self->{'role'} = "Invalid";
						} elsif ($self->{'role'} eq "Invalid") {
							$self->{'role'} = "Invalid";
						} else {
							$self->{'role'} = "PRIMARY";
						}
					} else {
						$self->{MIR_ROLES}{$mirror} = "SECONDARY";
						if ($self->{'role'} eq "PRIMARY") {
							$self->{'role'} = "Invalid";
						} elsif ($self->{'role'} eq "Invalid") {
							$self->{'role'} = "Invalid";
						} else {
							$self->{'role'} = "SECONDARY";
						}
					}
				} elsif ($q =~ /Image State/) {
					my @stateinfo = split('\s+', $q);
					$self->{MIR_STATES}{$mirror} = $stateinfo[2];
				} elsif ($q =~ /Image Condition/) {
					my @conditioninfo = split('\s+', $q);
					$self->{MIR_CONDITIONS}{$mirror} = $conditioninfo[2];
				} elsif ($q =~ /Image UID/) {
					my @uids = split('\s+', $q);
					if ( $localUID eq "" ) {
						$self->{MIR_IMAGEUID}{$mirror} = $uids[2];
						$localUID = $uids[2];
					} else {
						$self->{MIR_REMOTEUID}{$mirror} = $uids[2];
					}
				} elsif ($q =~ /Update Type/) {
					my @updateinfo = split('\s+', $q);
					$self->{MIR_UPDATETYPE}{$mirror} = $updateinfo[2];
					if ($self->{MIR_UPDATETYPE}{$mirror} eq "Manual") {
						$self->{MIR_UPDATETIME}{$mirror} = 0;
						last;
					} else {
						$self->{MIR_UPDATETYPE}{$mirror} = $updateinfo[5];
						next;
					}
				}elsif ($q =~ /Update Period, in minutes/) {
					my @times = split('\s+', $q);
					$self->{MIR_UPDATETIME}{$mirror} = $times[4];
					last;
				}
			}
		}
	}
	if (!$self->{'role'}) {
		$self->{'role'} = "Invalid";
	}
}

sub failover_required {
	my ($self) = shift;
	if ($self->{'role'} eq "Invalid") {
		return 2;
	}
	if ($self->{'role'} eq "SECONDARY") {
		return 1;
	}
	return 0;
}

sub wait_for_sync {
	my $self = shift;

	my $i = 0;
	my $wait_req = 0;
        my ($oto) = split('\n', `$vcs_home/bin/hatype -value MirrorView OnlineTimeout
`);
        my $cur_time = time();
        my $remaining_time = ($oto - ($cur_time - $self->{'start_time'}));
        my $count = int($remaining_time / 20) - 1;
        if ($count <= 0) {
                return 1;
        }
	my $j =0;
	while ($j < $count) {
		$wait_req = 0;
		for($i=0; $i<$self->{'numMirrors'}; $i++){
			my $mirror = $self->{mirnames}[$i];
			my $state = $self->{MIR_STATES}{$mirror};
			if ($state eq "Synchronized") {
				next;
			} elsif (($state eq "Synchronizing") || ($state eq "Consistent")) {
				$wait_req++;
			}
		}	
		if ($wait_req) {
			my $cmd = "sleep 10";
			system ($cmd);
			my $nolog=1;
			$self->get_state($nolog);
		} else {
			VCSAG_LOG_MSG("N", "Devices are Synchronized", 5);
			return 0;
		}
		$j++;
	}
	if ($j == $count) {
		VCSAG_LOG_MSG("W", "Devices are still in Consistent state", 6);
		return 1;
	} 
	VCSAG_LOG_MSG("N", "Devices are Synchronized", 5);
	return 0;
}

sub mirror_takeover {
	my ($self) = @_;
	my $fractured_images = 0;

	# If remote array is avaialble, check to see if the image condition is 
	# not FRACTURED
	VCSAG_LOG_MSG("W", "Checking the image condition of the remote mirrors", 7);
	my $remcmd = $java_home . "/java -jar " . $self->{'naviclihome'} . "/navicli.jar -h " .  $self->{'remotearray'}  . " mirror " . $self->{'flag'} . " -list -name ";
	my $logremcmd = "$java_home/java -jar $self->{'naviclihome'}/navicli.jar -h $self->{'remotearray'} mirror $self->{'flag'} -list -name ";

	my $i=0;
	for($i=0; $i<$self->{'numMirrors'}; $i++){
		my $mirror = $self->{mirnames}[$i];
		my $remoteCondition = "";
		my $remoteState = "";
			
		my $logcmd = $logremcmd . " $mirror";
		log_command($logcmd);

		my @query = split('\n', `$remcmd $mirror`);
		foreach my $q (@query) {
			if ($q =~ /Image State/) {
				my @currState = split('\s+', $q);
				$remoteState = $currState[2];
				next;
			}
			if ($q =~ /Image Condition/) {
				my @conditions = split('\s+', $q);
				$remoteCondition = $conditions[2];
			}
		}
		my $localCondition = $self->{MIR_CONDITIONS}{$mirror};
		my $localState = $self->{MIR_STATES}{$mirror};

		if (($remoteState eq "") && ($remoteCondition eq "")) {
			VCSAG_LOG_MSG("E", "For mirror $mirror, there is no secondary image available. Administrative Intervention required.", 8, $mirror);
			return 2;
		}

		if (($localCondition eq "fractured") || ($remoteCondition eq "fractured") || ($localState ne $remoteState) || ($localCondition ne $remoteCondition)) {
			$fractured_images++;
		}
	}
	if ($fractured_images) {
		VCSAG_LOG_MSG("N", "$fractured_images mirrors are in FRACUTRED condition. Possible link failures.", 9, $fractured_images);
		return 1;
	}
	return 0;
}

sub failover {
	my $self = shift;
	my $ret = 0;
	my $force = 0;

	# Determine if the remotearray is accessible or not
	if ($self->{'remotearray'} eq "NOARRAYSP") {
        	VCSAG_LOG_MSG("N", "Remote array $self->{'remotearray'} is unreachable.", 10, $self->{'remotearray'} );
		$force = 1;
		if ($self->{'mode'} eq "sync") {
			$ret = $self->mirror_failover();
		} elsif ($self->{'grpname'} ne "") {
			$ret =  $self->grp_promote($force);
		} else {
			$ret = $self->async_mirror_failover($force);
		}
		return $ret;
	}

	if ($self->{'mode'} eq "sync") {
		$ret = $self->mirror_takeover();
		# Remote mirror doesn't exist.
		if ($ret == 2) {
			return $ret;
		}

		if (($ret) && ($self->{'splitTakeover'} == 0)) {
			VCSAG_LOG_MSG("E", "Link Failure has been detected. Since SplitTakeover flag is set to 0, VCS will not failover. Administrative intervention required.", 11);
			return $ret;
		}
		$ret = $self->mirror_failover();
	} elsif (($self->{'mode'} eq "async") && ($self->{'grpname'} ne "")) {
		$force = 0;
		$ret = $self->grp_promote($force);
		if ($ret == 1) {
			$ret = $self->synchronize_grp();
			if (!$ret) {
				$force = 0;
				$ret = $self->grp_promote($force);
			} 
		}
	} else {
		$ret = $self->mirror_takeover();
		# Remote mirror doesn't exist.
		if ($ret == 2) {
			return $ret;
		}
		$force = 0;
		$ret = $self->async_mirror_failover($force);
		if ($ret == 1) {
			$ret = $self->async_synchronize_mirror();
			if (!$ret) {
				$force = 0;
				$ret = $self->async_mirror_failover($force);
			} 
		}
	}

	return $ret;
}

sub mirror_failover {
        my ($self) = @_;
        my $i=0;

        my $cmd = $java_home . "/java -jar " . $self->{'naviclihome'} . "/navicli.jar -h " .  $self->{'arrayname'} . " mirror " . $self->{'flag'} . " -promoteimage -name ";
        my $logcmd = "$java_home/java -jar $self->{'naviclihome'}/navicli.jar -h $self->{'arrayname'} mirror $self->{'flag'} -promoteimage -n
ame ";

        my $autocmd = $java_home . "/java -jar " . $self->{'naviclihome'} . "/navicli.jar -h " .  $self->{'arrayname'} . " mirror " . $self->
{'flag'} . " -changeimage -name ";
        my $logautocmd = "$java_home/java -jar $self->{'naviclihome'}/navicli.jar -h $self->{'arrayname'} mirror $self->{'flag'} -changeimage
 -name ";

        for($i=0; $i<$self->{'numMirrors'}; $i++){
                my $mirror = $self->{mirnames}[$i];
                my $remoteUID = $self->{MIR_REMOTEUID}{$mirror};
                my $localUID = $self->{MIR_IMAGEUID}{$mirror};
                my $newcmd = $cmd . $mirror . " -imageuid " . $remoteUID . " -o";
                my $logcmd = "$logcmd $mirror -imageuid $remoteUID -o";

                VCSAG_LOG_MSG("W", "Promoting the mirror: $mirror", 12, $mirror);
                log_command($logcmd);

                my $ret = system($newcmd);
                if ($ret) {
                        VCSAG_LOG_MSG("E", "Unable to promote the image for $mirror", 13, $mirror);
                        return 1;
                }
                # once you promote an image, recoverypolicy becomes 'manual'
                # we have to change the recoverypolicy back to 'auto'
                my $newauto = $autocmd . $mirror . " -imageuid " . $localUID . " -recoverypolicy auto -o";

                my $lognewauto = "$logautocmd $mirror -imageuid $localUID -recoverypolicy auto -o";

                VCSAG_LOG_MSG("W", "Changing the recovery policy to 'auto' for mirror: $mirror", 14, $mirror);
                log_command($lognewauto);
                $ret = system ("$newauto");
                if ($ret) {
                        VCSAG_LOG_MSG("W", "Unable to change the 'recoverypolicy' to auto for $mirror mirror.", 15, $mirror);
                }
        }
}

sub async_mirror_failover {
	my ($self) = shift;
	my ($force) = shift;
	my ($retVal) = 0;
	my $i=0;

	my $cmd = $java_home . "/java -jar " . $self->{'naviclihome'} . "/navicli.jar -h " .  $self->{'arrayname'} . " mirror " . $self->{'flag'} . " -promoteimage -name ";
	my $logcmd = "$java_home/java -jar $self->{'naviclihome'}/navicli.jar -h $self->{'arrayname'} mirror $self->{'flag'} -promoteimage -name ";

	my $autocmd = $java_home . "/java -jar " . $self->{'naviclihome'} . "/navicli.jar -h " .  $self->{'arrayname'} . " mirror " . $self->{'flag'} . " -changeimage -name ";
	my $logautocmd = "$java_home/java -jar $self->{'naviclihome'}/navicli.jar -h $self->{'arrayname'} mirror $self->{'flag'} -changeimage -name ";

	if (!($force)){
		for($i=0; $i<$self->{'numMirrors'}; $i++){
			my $mirror = $self->{mirnames}[$i];
			my $remoteUID = $self->{MIR_REMOTEUID}{$mirror};
			my $localUID = $self->{MIR_IMAGEUID}{$mirror};
			my $newcmd = $cmd . $mirror . " -imageuid " . $remoteUID . " -o";
			my $logcmd = "$logcmd $mirror -imageuid $remoteUID -o";

			VCSAG_LOG_MSG("W", "Promoting the mirror: $mirror", 12, $mirror);
			log_command($logcmd);

			my @query = split ('\n', `$newcmd`);
			$retVal = $?;

         		if ($retVal) {
                        	VCSAG_LOG_MSG("E", "Unable to promote the image for $mirror", 13, $mirror);
                	}

			foreach my $q (@query) {
				if (($q =~ /The image specified to be promoted was unable to contact other images in the mirror/)
					|| ($q =~ /0x7152807c/)) {
					VCSAG_LOG_MSG("W", "The image specified to be promoted: '$mirror' was unable to contact other images in the mirror.", 16, $mirror);
					$retVal = 2;
				} elsif (($q =~ /0x7152807d/) || ($q =~ /cause the existing primary to become out-of-sync./)) {
					VCSAG_LOG_MSG("W", "Cannot promote mirror '$mirror' as the existing primary will become out-of-sync.", 17, $mirror);
					$retVal = 1;
				} elsif (($q =~ /0x7152818f/) || ($q =~ /MirrorView\/A promote failed since the primary image is currently updating the./)) {

					VCSAG_LOG_MSG("W", "Cannot promote image '$mirror' as secondary image is being updated.", 18, $mirror);
					$retVal = 1;
				}
			}
		}
	}

	if (($force) || ($retVal == 2)){
		if ($self->{'splitTakeover'} == 0) {
			VCSAG_LOG_MSG("E", "Link Failure has been detected. Since SplitTakeover is set to 0, VCS will not failover. Administrative intervention required.", 11);
			exit(0);
		}

		for($i=0; $i<$self->{'numMirrors'}; $i++){
			my $mirror = $self->{mirnames}[$i];
			my $remoteUID = $self->{MIR_REMOTEUID}{$mirror};
			my $localUID = $self->{MIR_IMAGEUID}{$mirror};
			my $newcmd = $cmd . $mirror . " -imageuid " . $remoteUID . " -type oos -o";
			my $logcmd = "$logcmd $mirror -imageuid $remoteUID -type oos -o";

			VCSAG_LOG_MSG("W", "Promoting the image: $mirror forcibly.", 19, $mirror);
			log_command($logcmd);

			my @query = split ('\n', `$newcmd`);
			foreach my $q (@query) {
				if ($q =~ /Primary Image Status: Local Promote succeeded/)  {
					VCSAG_LOG_MSG("W", "Local Promote succeeded for mirror :$mirror", 20, $mirror);
					$retVal = 0;
				} 
				if ($q =~ /0x71528003/)  {
					VCSAG_LOG_MSG("W", "Unable to send a message to the secondary or peer SP.", 21);
					last;
				}
			}
			if ($retVal) {
				VCSAG_LOG_MSG("W", "Failure promoting the image $mirror forcibly", 22, $mirror);
			}
		}
	}

	return $retVal;
}

sub grp_promote {
	my ($self) = shift;
	my ($force) = shift;
	my $retVal = 0;

	my $cmd = $java_home . "/java -jar " . $self->{'naviclihome'} . "/navicli.jar -h " . $self->{'arrayname'} . " mirror -async -promotegroup -name " . $self->{'grpname'}; 
	my $logcmd = "$java_home/java -jar $self->{'naviclihome'}/navicli.jar -h $self->{'arrayname'} mirror -async -promotegroup -name $self->{'grpname'}"; 

	# normal promote 
	if (!($force)){
		my $cmd = $cmd . " -o";
		my $logcmd = $logcmd . "-o";

		VCSAG_LOG_MSG("W", "Promoting the group: $self->{'grpname'} normally.", 23, $self->{'grpname'});
		log_command($logcmd);

		my @query = split ('\n', `$cmd`);
		foreach my $q (@query) {
			if (($q =~ /Unable to contact MirrorView\/A on remote array/)
				|| ($q =~ /0x715280fd/)) {
				VCSAG_LOG_MSG("W", "Unable to contact MirrorView\/A on remote array.", 24);
				$retVal = 2;
			} elsif (($q =~ /0x71528031/) || ($q =~ /cause the existing primary group to become out-of-sync.   Promote Locally or Force Promote needs to be selected./)) {
				VCSAG_LOG_MSG("W", "Cannot promote group '$self->{'grpname'}' as the existing primary group will become out-of-sync.", 25, $self->{'grpname'});
				$retVal = 1;
			} elsif (($q =~ /0x715281bb/) || ($q =~ /Cannot proceed with promote as group update is in progress./)) {
				VCSAG_LOG_MSG("W", "Cannot promote group '$self->{'grpname'}' as group update is in progress.", 26, $self->{'grpname'});
				$retVal = 1;
			}
		}
	}

	# force promote -in case of a disaster or a link failure (i.e. a normal promote fails)
	if (($force) || ($retVal == 2)){

		if ($self->{'splitTakeover'} == 0) {
			VCSAG_LOG_MSG("E", "Link Failure has been detected. Since SplitTakeover is set to 0, VCS will not failover. Administrative intervention required.", 11);
			exit(0);
		}

		VCSAG_LOG_MSG("W", "Promoting the group: $self->{'grpname'} forcibly.", 27, $self->{'grpname'});

		my $cmd = $cmd . " -type oos -o";
		my $logcmd = $logcmd . " -type oos -o";

		log_command($logcmd);

		my @query = split ('\n', `$cmd`);
		foreach my $q (@query) {
			if ($q =~ /Local Status: Local Promote succeeded/)  {
				VCSAG_LOG_MSG("W", "Local Promote succeeded for group :$self->{'grpname'}", 28, $self->{'grpname'});
				$retVal = 0;
			} 
			if ($q =~ /0x71528003/)  {
				VCSAG_LOG_MSG("W", "Secondary or peer SP is unreachable.", 29);
				last;
			}
		}
		if ($retVal) {
			VCSAG_LOG_MSG("W", "Failure promoting the group $self->{'grpname'} forcibly", 30, $self->{'grpname'});
		}
	}

	if ($retVal == 0){
		my $logcmd = "$java_home/java -jar $self->{'naviclihome'}/navicli.jar -h $self->{'arrayname'} mirror -async -changegroup -name $self->{'grpname'} -recoverypolicy auto -o > /dev/null 2>&1" ;

		VCSAG_LOG_MSG("W", "Changing the recovery policy to 'auto' for the group: $self->{'grpname'}", 31, $self->{'grpname'});
		log_command($logcmd);

		my $cmd = $java_home . "/java -jar $self->{'naviclihome'}/navicli.jar -h $self->{'arrayname'} mirror -async -changegroup -name $self->{'grpname'} -recoverypolicy auto -o > /dev/null 2>&1" ;
                my $ret = system("$cmd");
		if ($ret) {
			VCSAG_LOG_MSG("W", "Unable to set the 'recoverypolicy' for group : $self->{'grpname'} to 'auto'.", 32, $self->{'grpname'});
		}
	} elsif ($retVal == 1){
		VCSAG_LOG_MSG("W", "Unable to promote the group: $self->{'grpname'} ", 33, $self->{'grpname'});
	}

	return $retVal;
}

sub synchronize_grp {
	my ($self) = @_;
	my $cmd;
	my $retVal;

	# first check for -listgroups -name <> -update
	# if update type = manual, 
	#            just issue '-syncgroup -name<> -synctype startnow'
	# if update type = Time elapsed since end of last update
	#                                     ^^^  
	# store that type=end
	# store the time
	# i have to -changegroup -manualupdate
	#           -syncgroup -name <> -synctype startnow
	# once synchronized, 
	#	    -changegroup -enddelay <time>
	#
	# if update type = Time elapsed since start of last update
	#                                     ^^^^^
	# store that type=start
	# store the time
	# i have to -changegroup -manualupdate
	#           -syncgroup -name <> -synctype startnow
	# once synchronized, 
	#	    -changegroup -delaystart <time>
	#

	if ($self->{'grpudpatetype'} ne "Manual") { 
		$cmd = $java_home . "/java -jar " . $self->{'naviclihome'} . "/navicli.jar -h " . $self->{'remotearray'} . " mirror -async -changegroup -name "  . $self->{'grpname'} . " -manualupdate -o";
		
		my $logcmd = "$java_home/java -jar $self->{'naviclihome'}/navicli.jar -h $self->{'remotearray'} mirror -async -changegroup -name $self->{'grpname'}  -manualupdate -o";
		VCSAG_LOG_MSG("W", "Changing the update policy to 'manualupdate' for the group: $self->{'grpname'}", 34, $self->{'grpname'});
                log_command($logcmd);

		my $ret = system("$cmd");
		if ($ret) {
			VCSAG_LOG_MSG("W", "Unable to change the updatepolicy for group $self->{'grpname'} to  manualupdate.", 35, $self->{'grpname'});
			exit 0;
		} else {
			VCSAG_LOG_MSG("W", "Successful in changing the updatepolicy for group $self->{'grpname'} to  manualupdate.", 36, $self->{'grpname'});
		}
	}

	VCSAG_LOG_MSG("W", "Initiating synchronization for group $self->{'grpname'}.", 37, $self->{'grpname'});

	$cmd = $java_home . "/java -jar " . $self->{'naviclihome'} . "/navicli.jar -h " . $self->{'remotearray'} . " mirror -async -syncgroup -name "  . $self->{'grpname'} . " -synctype startnow -o";
		
	my $logcmd = "$java_home/java -jar $self->{'naviclihome'}/navicli.jar -h $self->{'remotearray'} mirror -async -syncgroup -name $self->{'grpname'} -synctype startnow -o";
	log_command($logcmd);

	my $ret = system("$cmd");
		
	if ($self->{'grpudpatetype'} ne "Manual") {
		if ($self->{'grpudpatetype'} eq "end") { 
			my $logcmd = "$java_home/java -jar $self->{'naviclihome'}/navicli.jar -h $self->{'remotearray'} mirror -async -changegroup -name $self->{'grpname'} -enddelay $self->{'grpupdatetime'} -o";

			VCSAG_LOG_MSG("W", "Changing the updatepolicy to 'enddelay' for the group: $self->{'grpname'}", 38, $self->{'grpname'});
			log_command($logcmd);
			$cmd = $java_home . "/java -jar " . $self->{'naviclihome'} . "/navicli.jar -h " . $self->{'remotearray'} . " mirror -async -changegroup -name "  . $self->{'grpname'} . " -enddelay " . $self->{'grpupdatetime'} . " -o";
			$ret = system("$cmd");
		} else { 
			my $logcmd = "$java_home/java -jar $self->{'naviclihome'}/navicli.jar -h $self->{'remotearray'} mirror -async -changegroup -name $self->{'grpname'} -delaystart $self->{'grpupdatetime'} -o";
			VCSAG_LOG_MSG("W", "Changing the updatepolicy to 'delaystart' for the group: $self->{'grpname'}", 39, $self->{'grpname'});
			log_command($logcmd);
			$cmd = $java_home . "/java -jar " . $self->{'naviclihome'} . "/navicli.jar -h " . $self->{'remotearray'} . " mirror -async -changegroup -name "  . $self->{'grpname'} . " -delaystart " . $self->{'grpupdatetime'} . " -o";
			$ret = system("$cmd");
		}

		if ($ret) {
			VCSAG_LOG_MSG("W", "Unable to change back the update policy for group $self->{'grpname'}.", 40, $self->{'grpname'});
			exit 0;
		} else {
			VCSAG_LOG_MSG("W", "Successful in setting the update time for group $self->{'grpname'} to  $self->{'grpupdatetime'} minutes.", 41, $self->{'grpname'}, $self->{'grpupdatetime'});
		}
	}

	my $i=0;
	for( $i=0; $i < $self->{'RETRY_ATTEMPTS'}; $i++ ) {

		my $nolog=1;
		$self->get_state($nolog);

		if ($self->{'state'} eq "Synchronized") {
			VCSAG_LOG_MSG("W", "Group:$self->{'grpname'} has been synchronized.", 42, $self->{'grpname'});
			last;
		}

		sleep 10;
	}
	
	if ($i < $self->{'RETRY_ATTEMPTS'}) {
		$retVal = 0;
	}else {
		VCSAG_LOG_MSG("W", "Error synchronizing the group. Cannot promote the group: $self->{'grpname'} ", 43, $self->{'grpname'});
		$retVal = 1;
	} 
	return $retVal
}

sub async_synchronize_mirror {
	my ($self) = shift;
	my $cmd;
	my $retVal;

	my $autocmd = $java_home . "/java -jar " . $self->{'naviclihome'} . "/navicli.jar -h " .  $self->{'remotearray'} . " mirror " . $self->{'flag'} . " -changeimage -name ";
	my $logautocmd = "$java_home/java -jar $self->{'naviclihome'}/navicli.jar -h $self->{'remotearray'} mirror $self->{'flag'} -changeimage -name ";

	my $i=0;
	for($i=0; $i<$self->{'numMirrors'}; $i++){
		my $mirror = $self->{mirnames}[$i];
		my $localUID = $self->{MIR_IMAGEUID}{$mirror};
		my $remoteUID = $self->{MIR_REMOTEUID}{$mirror};
		my $mirrorupdatetype = $self->{MIR_UPDATETYPE}{$mirror};
		my $mirrorupdatetime = $self->{MIR_UPDATETIME}{$mirror};

		# once you promote an image, recoverypolicy becomes 'manual'
		# we have to change the recoverypolicy back to 'auto'

		if ($mirrorupdatetype ne "Manual") { 
			my $newauto = $autocmd . $mirror . " -imageuid " . $remoteUID . " -manualupdate -o";

			my $lognewauto = "$logautocmd $mirror -imageuid $remoteUID -manualupdate -o";

			VCSAG_LOG_MSG("W", "Changing the update policy to 'manualupdate' for mirror: $mirror", 44, $mirror);
			log_command($lognewauto);

			$retVal = system ("$newauto");
			if ($retVal) {
				VCSAG_LOG_MSG("W", "Unable to change the updatepolicy for mirror $mirror to manualupdate.", 45, $mirror);
				exit 0;
			} else {
				VCSAG_LOG_MSG("W", "Successful in changing the updatepolicy for mirror $mirror to  manualupdate.", 46, $mirror);
			}
		}

		VCSAG_LOG_MSG("W", "Initiating synchronization for mirror $mirror.", 47, $mirror);

		$cmd = $java_home . "/java -jar " . $self->{'naviclihome'} . "/navicli.jar -h " . $self->{'remotearray'} . " mirror -async -syncimage -name $mirror -imageuid $remoteUID -o";
		my $logcmd = "$java_home/java -jar $self->{'naviclihome'}/navicli.jar -h $self->{'remotearray'} mirror -async -syncimage -name $mirror -imageuid $remoteUID -o";
		log_command($logcmd);
	
		my $ret = system("$cmd");
		
		if ($mirrorupdatetype ne "Manual") {
			if ($self->{MIR_UPDATETYPE}{$mirror} eq "end") { 
				my $logcmd = "$java_home/java -jar $self->{'naviclihome'}/navicli.jar -h $self->{'remotearray'} mirror -async -changeimage -name $mirror -imageuid $remoteUID -enddelay $self->{MIR_UPDATETIME}{$mirror} -o";

				VCSAG_LOG_MSG("W", "Changing the updatepolicy to 'enddelay' for the mirror: $mirror", 48, $mirror);
				log_command($logcmd);
				$cmd = $java_home . "/java -jar " . $self->{'naviclihome'} . "/navicli.jar -h " . $self->{'remotearray'} . " mirror -async -changeimage -name "  . $mirror . " -imageuid " . $remoteUID . " -enddelay " . $self->{MIR_UPDATETIME}{$mirror} . " -o";
				$ret = system("$cmd");
			} else { 
				my $logcmd = "$java_home/java -jar $self->{'naviclihome'}/navicli.jar -h $self->{'remotearray'} mirror -async -changeimage -name $mirror -imageuid $remoteUID -delaystart $self->{MIR_UPDATETIME}{$mirror} -o";
				VCSAG_LOG_MSG("W", "Changing the updatepolicy to 'delaystart' for the mirror: $mirror", 49, $mirror);
				log_command($logcmd);

				$cmd = $java_home . "/java -jar " . $self->{'naviclihome'} . "/navicli.jar -h " . $self->{'remotearray'} . " mirror -async -changeimage -name " . $mirror . " -imageuid " . $remoteUID . " -delaystart " . $self->{MIR_UPDATETIME}{$mirror} . " -o";
				$ret = system("$cmd");
			}

			if ($ret) {
				VCSAG_LOG_MSG("W", "Unable to change back the update policy for mirror $mirror.", 50, $mirror);
				exit 0;
			} else {
				VCSAG_LOG_MSG("W", "Successful in setting the update time for mirror $mirror to $self->{MIR_UPDATETIME}{$mirror} minutes.", 51, $mirror, $self->{MIR_UPDATETIME}{$mirror});
			}
		}

	} #end for loop


	$retVal = $self->wait_for_sync();

	return $retVal
}

sub log_command {
        my ($cmd) = @_;
        VCSAG_LOG_MSG("W", "Cmd being fired is: $cmd", 52, $cmd);
        return ;
}

sub do_command {
        my ($cmd) = @_;
        my $output = `$cmd 2>&1`;
        my $status = $? >> 8;

        return ($status, $output);
}

#
# PingTest - ping host to find out if it is alive
# returns
#  0 if alive
#  1 otherwise
#
sub PingTest {
        my ($host) = @_;
        my $cmd;
	my $SYSTEM;
	my @sysinfo;

	@sysinfo = uname ();
	$SYSTEM = $sysinfo[0];

	if ($SYSTEM eq "AIX")
	{
        	$cmd="ping -c 1 $host";
	}
	elsif ($SYSTEM eq "HP-UX")
	{
        	$cmd="ping $host -n 1";
	}
	elsif ($SYSTEM eq "Linux")
	{
        	$cmd="ping -c 1 $host";
	}
	elsif ($SYSTEM eq "SunOS")
	{
        	$cmd="ping $host 1";
	}
        my ($status, $output) = do_command($cmd);
        return 1 if ($output =~ /no answer from/);
        return 1 if ($output =~ /unknown host/);
        return 1 if ($output =~ /could not find host/);
        return 1 if ($output =~ /Request timed out/);
	return 1 if ($status);
        return 0;
}

# These are 'resync' related functions

sub grp_resync {
        my($self) = shift;
	$self->get_state ();
        if ($self->{'role'} eq "PRIMARY") {
                VCSAG_LOG_MSG("W", "The group $self->{'grpname'} is PRIMARY and  hence it is SYNCHORNIZED.", 55, $self->{'grpname'});
                return 0;
        }
	my $ret = $self->synchronize_grp ();
	return $ret;
}

sub mirror_resync {
        my($self) = shift;
	my $localState = "";
	my $localCondition = "";
	my $localUID = "";
	my $remoteUID = "";
	
	$self->get_state();

	# if image condition is fractured, then first
	# Administratively fracture the image
	# and issue -syncimage command
	my $cmd = $java_home . "/java -jar " . $self->{'naviclihome'} . "/navicli.jar -h " .  $self->{'arrayname'} . " mirror " . $self->{'flag'} . " -fractureimage -name ";
	my $sync_cmd = $java_home . "/java -jar " . $self->{'naviclihome'} . "/navicli.jar -h " .  $self->{'arrayname'} . " mirror " . $self->{'flag'} . " -syncimage -name ";
	for(my $i=0; $i<$self->{'numMirrors'}; $i++){
		my $mirror = $self->{mirnames}[$i];
		$localCondition = $self->{MIR_CONDITIONS}{$mirror};
		$localUID = $self->{MIR_IMAGEUID}{$mirror};
		$remoteUID = $self->{MIR_REMOTEUIDS}{$mirror};
		
		if ($localCondition eq "fractured") {
			my $newcmd = $cmd . $mirror . " -imageuid " . $remoteUID . " -o";
			my $ret = system("$newcmd");
			if ($ret) {
				VCSAG_LOG_MSG("W", "Error fracturing the image for $mirror on the array:$self->{'arrayname'}", 53, $mirror, $self->{'arrayname'});
			}
			$newcmd = $sync_cmd . $mirror . " -imageuid " . $remoteUID . " -o";
			my $ret = system("$newcmd");
			if ($ret) {
				VCSAG_LOG_MSG("W", "Unable to synchronize the secondary image from the $mirror, command output", 54, $mirror);
			}
		}
	}
}
